<?php
namespace Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Teknisa\GER\Utilities\Environment;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\Controller;
use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO\Response\Notification;


class Ger23300ImportacaoDeLancamentosDeDespesaController extends \Teknisa\Libs\Controller\CRUD {
    protected $dataSourceManager;
    protected $connection;
    protected $environment;

    public function __construct($crudService, $environment, $connection, $dataSourceManager ) {
        $this->dataSourceManager    = $dataSourceManager;
        $this->connection = $connection;
        $this->environment = $environment;
        parent::__construct($crudService, $environment);
    }
    
    public function buscaDados(DTO\Request $request,  DTO\Response $response){
        $currentRow = $request->getDataSet()->getRows()[0];
        
		try{
		    
	        $stmt = $this->connection->prepare(
		        "SELECT DSURLHCM, DSIDHCM, DSSECRETHCM, DSTOKENHCM FROM PARAMGERAL"
    		);
    		$stmt->execute();
			$result = $stmt->fetchAll()[0];
		    
		    if($currentRow['OPCOES_SERVICES'] == 0){
		        $url_produ = $result["DSURLHCM"];
		    }else{
		        $url_produ = $currentRow["textoDeOutro"];
		    }

	        $cdfilial = $currentRow['CDFILIAL'];
            $secret = $result['DSSECRETHCM'];
            
            // $token = $this->requestToken($cdfilial, $secret)['dataset']['token'][0]; 
            $token = $result['DSTOKENHCM']; 
            //caso precise pegar o cnpj das filiais, utilizar código abaixo:
            /*
            $getCnpj = $this->connection->prepare(
		        "SELECT NRINSJURFILI FROM FILIAL WHERE CDFILIAL = :CDFILIAL AND NRORG = :NRORG"
    		);
    		$getCnpj->execute();
            $cnpj = $getCnpj->fetchAll()[0]; 
            */  

            $mescompetencia = "01/".$currentRow['PERIODO'];
            $filial_Nutrisaude = $currentRow['CDFILIAL'];;
            
            $nrtpmoviment = "1";
            
            /* Nutrisaude */
            $dados = $this->retornaResumoDespesaPorDataMovimento($url_produ, $secret, $token, $filial_Nutrisaude, $mescompetencia, $nrtpmoviment);
            
            if(is_array($dados) && array_key_exists('error', $dados)){
                $token = $this->requestToken($cdfilial, $secret)['dataset']['token'][0];     
                $dados = $this->retornaResumoDespesaPorDataMovimento($url_produ, $secret, $token, $filial_Nutrisaude, $mescompetencia, $nrtpmoviment);
            }
            
			if(is_array($dados) && array_key_exists('dataset', $dados)){
    			$dados = $this->adicionaStatus($dados);
    			$response->addDataSet(new DataSet("despesas", $dados['dataset']['despesas']));
			}else if (is_array($dados) && array_key_exists('messages', $dados) && $dados['messages'][0]['type'] == 'E'){
			    $response->addDataSet(new DataSet("error", $dados['messages'][0]));
			}else{
			    $response->addDataSet(new DataSet("error", ["Não foi possivel buscar dados para os parâmetros enviados. URL inválido."]));
			}
			
        }catch(\Exception $ex){
        	$response->setError(new Error("Unidade não habilitada para utilizar o HCM." , 500));
        }
	}
	
	public function requestToken($nrorg, $secret){
	    $uri_local = "http://localhost:9090/hcmservices/backend/service/index.php/requestToken";
        $uri_produ = "http://hcmservices.pebbian.com/index.php/requestToken";

        $dataNutrisaude = array(
            "CLIENT_ID"     => "1019",
            "CLIENT_SECRET" => "875ddcf304a531d63d3baac7f865c697590a4fadec1f131"
        );
        
        $uri = $uri_produ;
        $data = $dataNutrisaude;
        
        $header[] = 'Content-Type: application/json';
        $header[] = 'Content-Length: ' . strlen(json_encode($data));
        try{
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
            curl_setopt($ch, CURLOPT_URL, $uri);
            curl_setopt($ch, CURLOPT_POST, count($data));
            curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
            curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
            
            $result = curl_exec($ch);
            $err    = curl_errno( $ch );
            $errmsg = curl_error( $ch );
            $header = curl_getinfo( $ch );
            curl_close($ch);
            
            $header['errno']   = $err;
            $header['errmsg']  = $errmsg;
            $header['content'] = json_decode($result, true);
            $stmt = $this->connection->prepare(
    		        "UPDATE PARAMGERAL
                        SET DSTOKENHCM = :P_DSTOKENHCM 
                      WHERE NRORG = :P_NRORG"
        		);
        	$manage = json_decode($result);
        	$params = array(
        	    'P_DSTOKENHCM' => $manage->dataset->token[0],
        	    'P_NRORG' => $nrorg
        	);
        	
        	
        	$stmt->execute($params);
            
        }catch(\Exception $ex){
        	$response->setError(new Error("ERRO_OPERACAO2". $ex->getMessage(), 500));
        }

        return json_decode($result, true);
        
	}
	
	public function executa_curl($token, $secret, $row, $uri) {
        $header = array(
            "OAuth-Token: ".$token, //Local
            "OAuth-SecretId: ".$secret
        );
    
        $data = array(
            'requestType' => 'Row',
            'row' => $row
        );
    
        $header[] = 'Content-Type: application/json';
        $header[] = 'Content-Length: ' . strlen(json_encode($data));
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
        curl_setopt($ch, CURLOPT_URL, $uri);
        curl_setopt($ch, CURLOPT_POST, count($data));
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
    
        $result = curl_exec($ch);
        curl_close($ch);
    
        return json_decode($result, true);
	    
	}
	
	public function retornaResumoDespesaPorDataMovimento($url, $secret, $token, $filial, $data, $movimento) {
        $rota = "/retornaResumoDespesaPorDataMovimento";
        $data = array(
            "FILIAL" => $filial,
            "DATA" => $data,
            "MOVIMENTO" => $movimento,
        );
    
        return $this->executa_curl($token, $secret, $data, $url.$rota);
    }
    
    public function saveDados(DTO\Request $request,  DTO\Response $response){
        $rows = $request->getDataSet()->getRows();
        
        foreach ($rows as $row) {
            try{
                $stmt = $this->connection->prepare(
        		    "INSERT INTO LANCDESPFATU (CDFILIAL, CDDESPADMFAT, DTLANCDESFAT, VRLANCDESFAT, VRPREVDESFAT)
                          VALUES (:P_CDFILIAL, :P_CDDESPADMFAT, :P_DTLANCDESFAT, :P_VRLANCDESFAT, :P_VRPREVDESFAT)"
            	);
            	$stmt->execute(
                    array(
                        'P_CDFILIAL'          => $row["cod_unidade"],
                        'P_CDDESPADMFAT'      => $row["cod_despesa"],
                        'P_DTLANCDESFAT'      => date("d/m/Y", strtotime($row['data'])),
                        'P_VRLANCDESFAT'      => $row["valor"],
                        'P_VRPREVDESFAT'      => $row["valor"]
                    )
                );
                
                
                $this->atualizaStatus($request, $response);
            }catch(\Exception $ex){
                if(strpos($ex->getMessage(), "ORA-00001") === FALSE){
                    $response->setError(new Error("ERRO_OPERACAO2". $ex->getMessage(), 500));
                }else{
                    $response->setError(new Error("Não é possível salvar dado!", 500));
                }
            }
        }
    }
    
    public function adicionaStatus($dados){
        
        if(is_array($dados["dataset"]["despesas"])){
            foreach ($dados["dataset"]["despesas"] as &$row) {
                
                if(strlen($row["data"]) != 10){
                    $row['data'] = date('d/m/Y',  strtotime(str_split($row['data'], 10)[0]));
                }
                
                $verifica = $this->connection->prepare(
                    "SELECT CDFILIAL, CDDESPADMFAT, DTLANCDESFAT FROM LANCDESPFATU WHERE :P_CDFILIAL = CDFILIAL AND :P_CDDESPADMFAT = CDDESPADMFAT AND :P_DTLANCDESFAT = DTLANCDESFAT"
                );

                $verifica->execute(
                    array(
                        'P_CDFILIAL'          => $row["cod_unidade"],
                        'P_CDDESPADMFAT'      => $row["cod_despesa"],
                        'P_DTLANCDESFAT'      => date("d/m/Y", strtotime($row['data']))
                    )
                );
                $result = $verifica->fetchAll();
                
                // $row['data'] = str_split($row['data'], 10)[0];
                
                if($result){
                    $row['STATUS'] = 'Lançamento de despesa já realizado.';
                    
                }else{
                    $despesa = $this->connection->prepare(
                        "SELECT CDDESPADMFAT FROM DESPADMFATUR WHERE :P_CDDESPADMFAT = CDDESPADMFAT"    
                    );
                    
                    $despesa->execute(
                        array(
                            'P_CDDESPADMFAT' => $row["cod_despesa"],    
                        )
                    );
                    
                    $resultDespesas = $despesa->fetchAll();
                    
                    if($resultDespesas){
                        $row['STATUS'] = 'Lançamento pendente para importação.';
                    }else{
                        $row['STATUS'] = 'Despesa não cadastrada.';
                    }
                    
                }
                    
            }
            return $dados;
        }else {
            return array();
        }
    }
    
    public function atualizaStatus(DTO\Request $request,  DTO\Response $response){
        $dados = $request->getDataSet()->getRows();
        $array = array();
        $array["dataset"]["despesas"] = $dados;
        $d = $this->adicionaStatus($array);
        $response->addDataSet(new DataSet("despesas", $d));
    
    }
    
}