<?php
namespace Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Teknisa\GER\Utilities\Environment;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\Controller;
use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO\Response\Notification;
 

class Ger80301ProjecaoManualController extends \Teknisa\Libs\Controller\CRUD{
    
    protected $dataSourceName = "projecaomanualrop";
    protected $dataSourceManager;
    protected $connection;
    protected $newCode;
    protected $environment;

    
    public function __construct($crudService, $environment, $dataSourceManager, $connection, $newCode) {
        parent::__construct($crudService, $environment);
        $this->dataSourceManager    = $dataSourceManager;
        $this->connection = $connection;
        $this->newCode = $newCode;
        $this->environment = $environment;
    }
    
    public function updateProjecao(DTO\Request $request, DTO\Response $response){
        $data = $request->getDataSet();
        $rows = $data->getRows();

        $rowsToSave = array();
        $currentTime = $this->crudService->getEnvironment()->getCurrentTime()->format("d/m/Y H:i:s"); 
        $rowsToSave['NRPROJECAOMANUALROP'] = $rows[0]['NRPROJECAOMANUALROP'];

        foreach($rows as $row){
            
            
            if ($row['CDITEMROP'] == 'FATEFET'){
                $rowsToSave['VRFATBRUTMAN'] = $row['VRPROJMANUAL'];
            }else if(!array_key_exists('VRFATBRUTMAN', $rowsToSave)){
                $rowsToSave['VRFATBRUTMAN'] = null;
            }
            if ($row['CDITEMROP'] == 'FATNF'){
                $rowsToSave['VRFATNFMAN'] = $row['VRPROJMANUAL'];
            }else if(!array_key_exists('VRFATNFMAN', $rowsToSave)){
                $rowsToSave['VRFATNFMAN'] = null;
            }
            if ($row['CDITEMROP'] == 'FATFOR'){
                $rowsToSave['VRFATFOSMAN'] = $row['VRPROJMANUAL'];
            }else if(!array_key_exists('VRFATFOSMAN', $rowsToSave)){
                $rowsToSave['VRFATFOSMAN'] = null;
            }
            if ($row['CDITEMROP'] == 'FATDIV'){
                $rowsToSave['VRFATDIVMAN'] = $row['VRPROJMANUAL'];
            }else if(!array_key_exists('VRFATDIVMAN', $rowsToSave)){
                $rowsToSave['VRFATDIVMAN'] = null;
            }
            if ($row['CDITEMROP'] == 'FATRECEXTRA'){
                $rowsToSave['VRFATRECEXTRAMAN'] = $row['VRPROJMANUAL'];
            }else if(!array_key_exists('VRFATRECEXTRAMAN', $rowsToSave)){
                $rowsToSave['VRFATRECEXTRAMAN'] = null;
            }
            // if ($row['CDITEMROP'] == 6){
            //     $rowsToSave['VRDEDURECMAN'] = $row['VRPROJMANUAL'];
            // }else if(!array_key_exists('VRDEDURECMAN', $rowsToSave)){
            //     $rowsToSave['VRDEDURECMAN'] = null;
            // }
            if ($row['CDITEMROP'] == 'DEDUIM'){
                $rowsToSave['VRIMPOSTOMAN'] = $row['VRPROJMANUAL'];
            }else if(!array_key_exists('VRIMPOSTOMAN', $rowsToSave)){
                $rowsToSave['VRIMPOSTOMAN'] = null;
            }
            if ($row['CDITEMROP'] == 'DEDUCR'){
                $rowsToSave['VRCREDIMPMAN'] = $row['VRPROJMANUAL'];
            }else if(!array_key_exists('VRCREDIMPMAN', $rowsToSave)){
                $rowsToSave['VRCREDIMPMAN'] = null;
            }
            if ($row['CDITEMROP'] == 'DEDUDEV'){
                $rowsToSave['VRDEDUDEVMAN'] = $row['VRPROJMANUAL'];
            }else if(!array_key_exists('VRDEDUDEVMAN', $rowsToSave)){
                $rowsToSave['VRDEDUDEVMAN'] = null;
            }
            if ($row['CDITEMROP'] == 'DEDUDES'){
                $rowsToSave['VRDESCSOBVENDAMAN'] = $row['VRPROJMANUAL'];
            }else if(!array_key_exists('VRDESCSOBVENDAMAN', $rowsToSave)){
                $rowsToSave['VRDESCSOBVENDAMAN'] = null;
            }
            if ($row['CDITEMROP'] == 'DEDUEN'){
                $rowsToSave['VRENCARGOMAN'] = $row['VRPROJMANUAL'];
            }else if(!array_key_exists('VRENCARGOMAN', $rowsToSave)){
                $rowsToSave['VRENCARGOMAN'] = null;
            }
            if ($row['CDITEMROP'] == 'TAXADM'){
                $rowsToSave['VRTAXAADMMAN'] = $row['VRPROJMANUAL'];
            }else if(!array_key_exists('VRTAXAADMMAN', $rowsToSave)){
                $rowsToSave['VRTAXAADMMAN'] = null;
            }
            if ($row['CDITEMROP'] == 'CMV' || $row['CDITEMROP'] == 'CONSUMO'){
                $rowsToSave['VRCONSUMOMAN'] = $row['VRPROJMANUAL'];
            }else if(!array_key_exists('VRCONSUMOMAN', $rowsToSave)){
                $rowsToSave['VRCONSUMOMAN'] = null;
            }
            // if ($row['CDITEMROP'] == 'VRMARCONTMAN'){
            //     $rowsToSave['VRMARCONTMAN'] = $row['VRPROJMANUAL'];
            // }else if(!array_key_exists('VRMARCONTMAN', $rowsToSave)){
            //     $rowsToSave['VRMARCONTMAN'] = null;
            // }
            if ($row['CDITEMROP'] == 'DESPESA'){
                $rowsToSave['VROUTRDESPMAN'] = $row['VRPROJMANUAL'];
            }else if(!array_key_exists('VROUTRDESPMAN', $rowsToSave)){
                $rowsToSave['VROUTRDESPMAN'] = null;
            }
            if ($row['CDITEMROP'] == 'AJUST'){
                $rowsToSave['VRAJUSTEMAN'] = $row['VRPROJMANUAL'];
            }else if(!array_key_exists('VRAJUSTEMAN', $rowsToSave)){
                $rowsToSave['VRAJUSTEMAN'] = null;
            }
            if ($row['CDITEMROP'] == 'DEBCRE'){
                $rowsToSave['VRDEBCREMAN'] = $row['VRPROJMANUAL'];
            }else if(!array_key_exists('VRDEBCREMAN', $rowsToSave)){
                $rowsToSave['VRDEBCREMAN'] = null;
            }
            if ($row['CDITEMROP'] == 'MAOBRA'){
                $rowsToSave['VRMAOOBRAMAN'] = $row['VRPROJMANUAL'];
            }else if(!array_key_exists('VRMAOOBRAMAN', $rowsToSave)){
                $rowsToSave['VRMAOOBRAMAN'] = null;
            }
            if ($row['CDITEMROP'] == 'DEPRE'){
                $rowsToSave['VRDEPRBENSMAN'] = $row['VRPROJMANUAL'];
            }else if(!array_key_exists('VRDEPRBENSMAN', $rowsToSave)){
                $rowsToSave['VRDEPRBENSMAN'] = null;
            }
            if ($row['CDITEMROP'] == 'INVEST'){
                $rowsToSave['VRINVESTMAN'] = $row['VRPROJMANUAL'];
            }else if(!array_key_exists('VRINVESTMAN', $rowsToSave)){
                $rowsToSave['VRINVESTMAN'] = null;
            }
        }

        try{
            $stmt = $this->connection->prepare("UPDATE PROJECAOMANUALROP
             SET
                VRFATBRUTMAN      = NVL(:P_VRFATBRUTMAN, VRFATBRUTMAN),
                VRFATNFMAN        = NVL(:P_VRFATNFMAN, VRFATNFMAN),
                VRFATFOSMAN       = NVL(:P_VRFATFOSMAN, VRFATFOSMAN),
                VRFATDIVMAN       = NVL(:P_VRFATDIVMAN, VRFATDIVMAN),
                VRFATRECEXTRAMAN  = NVL(:P_VRFATRECEXTRAMAN, VRFATRECEXTRAMAN),
                VRIMPOSTOMAN      = NVL(:P_VRIMPOSTOMAN, VRIMPOSTOMAN),
                VRCREDIMPMAN      = NVL(:P_VRCREDIMPMAN, VRCREDIMPMAN),
                VRDEDUDEVMAN      = NVL(:P_VRDEDUDEVMAN, VRDEDUDEVMAN),
                VRDESCSOBVENDAMAN = NVL(:P_VRDESCSOBVENDAMAN, VRDESCSOBVENDAMAN),
                VRENCARGOMAN     = NVL(:P_VRENCARGOMAN, VRENCARGOMAN),
                VRTAXAADMMAN      = NVL(:P_VRTAXAADMMAN, VRTAXAADMMAN),
                VRCONSUMOMAN      = NVL(:P_VRCONSUMOMAN, VRCONSUMOMAN),
                VROUTRDESPMAN     = NVL(:P_VROUTRDESPMAN, VROUTRDESPMAN),
                VRAJUSTEMAN       = NVL(:P_VRAJUSTEMAN, VRAJUSTEMAN),
                VRDEBCREMAN       = NVL(:P_VRDEBCREMAN, VRDEBCREMAN),
                VRMAOOBRAMAN      = NVL(:P_VRMAOOBRAMAN, VRMAOOBRAMAN),
                VRDEPRBENSMAN     = NVL(:P_VRDEPRBENSMAN, VRDEPRBENSMAN),
                VRINVESTMAN       = NVL(:P_VRINVESTMAN, VRINVESTMAN),
                
                DTULTATU = :P_DTULTATU,
                CDOPERULTATU = :P_CDOPERULTATU
             WHERE
               NRPROJECAOMANUALROP = :P_NRPROJECAOMANUALROP ");

            $stmt->execute(
                array(
                    'P_NRPROJECAOMANUALROP' => $rowsToSave['NRPROJECAOMANUALROP'],
                    'P_DTULTATU' => $currentTime,
                    'P_CDOPERULTATU' => $this->crudService->getEnvironment()->getCdOperador(),
                    'P_VRFATBRUTMAN'        => $rowsToSave['VRFATBRUTMAN'],
                    'P_VRFATNFMAN'          => $rowsToSave['VRFATNFMAN'],
                    'P_VRFATFOSMAN'         => $rowsToSave['VRFATFOSMAN'],
                    'P_VRFATDIVMAN'         => $rowsToSave['VRFATDIVMAN'],
                    'P_VRFATRECEXTRAMAN'    => $rowsToSave['VRFATRECEXTRAMAN'],
                    'P_VRIMPOSTOMAN'        => $rowsToSave['VRIMPOSTOMAN'],
                    'P_VRCREDIMPMAN'        => $rowsToSave['VRCREDIMPMAN'],
                    'P_VRDEDUDEVMAN'        => $rowsToSave['VRDEDUDEVMAN'],
                    'P_VRDESCSOBVENDAMAN'   => $rowsToSave['VRDESCSOBVENDAMAN'],
                    'P_VRENCARGOMAN'       => $rowsToSave['VRENCARGOMAN'],
                    'P_VRTAXAADMMAN'        => $rowsToSave['VRTAXAADMMAN'],
                    'P_VRCONSUMOMAN'        => $rowsToSave['VRCONSUMOMAN'],
                    'P_VROUTRDESPMAN'       => $rowsToSave['VROUTRDESPMAN'],
                    'P_VRAJUSTEMAN'         => $rowsToSave['VRAJUSTEMAN'],
                    'P_VRDEBCREMAN'         => $rowsToSave['VRDEBCREMAN'],
                    'P_VRMAOOBRAMAN'        => $rowsToSave['VRMAOOBRAMAN'],
                    'P_VRDEPRBENSMAN'       => $rowsToSave['VRDEPRBENSMAN'],
                    'P_VRINVESTMAN'         => $rowsToSave['VRINVESTMAN']
                )
            );
        }catch(\Exception $ex){
            if(strpos($ex->getMessage(), "ORA-00001") === FALSE){
                $response->setError(new Error("ERRO_OPERACAO2" . $ex->getMessage(), 500));
            }else{
                $response->setError(new Error("Não é possível alterar. Despesa já cadastrada para essa data!", 500));
            }
        }
        
        
    }
    
    public function saveServico(DTO\Request $request, DTO\Response $response){
        $row = $request->getDataSet()->getRows()[0];
        $parametros = array(
                'P_NRDETALHEPROJEMANROP' => $this->newCode->getCodeByTableName("DETALHEPROJEMANROP", $this->environment->getNrorg()),
                'P_CDITEM' => $row['CDITEM'],
                'P_DSITEM' => $row['DSITEM'],
                'P_CDFILIAL' => $row['CDFILIAL'],
                'P_DTINICIAL' => $row['DTINICIAL'],
                'P_DTFINAL' => $row['DTFINAL'],
                'P_VRITEM' => $row['VRITEM'],
                'P_QTITEM' => $row['QTITEM'],
                'P_QTDEITEMNAOUTIL' => $row['QTDEITEMNAOUTIL'],
                'P_QTDEITEMUTIL' => $row['QTDEITEMUTIL'],
                'P_VRITEMNAOUTIL' => $row['VRITEMNAOUTIL'],
                'P_VRITEMUTIL' => $row['VRITEMUTIL'],
                'P_NRORG' => $this->environment->getNrorg(),
                'P_DTINCLUSAO' => $this->crudService->getEnvironment()->getCurrentTime()->format("d/m/Y H:i:s"),
                'P_NRORGINCLUSAO' => $this->environment->getNrorg(),
                'P_CDOPERINCLUSAO' => $this->environment->getCdOperador(),
                'P_IDITEM' => 'FE',
                'P_IDATIVO' => 'S'
            );
         $stmt = $this->connection->prepare("
             INSERT INTO
                DETALHEPROJEMANROP 
            (
                NRDETALHEPROJEMANROP,
                CDITEM,
                DSITEM,
                CDFILIAL,
                DTINICIAL,
                DTFINAL,
                VRITEM,
                QTITEM,
                QTDEITEMNAOUTIL,
                QTDEITEMUTIL,
                VRITEMNAOUTIL,
                VRITEMUTIL,
                NRORG,
                DTINCLUSAO,
                NRORGINCLUSAO,
                CDOPERINCLUSAO,
                IDITEM,
                IDATIVO
             ) 
            VALUES(
                :P_NRDETALHEPROJEMANROP,
                :P_CDITEM,
                :P_DSITEM,
                :P_CDFILIAL,
                FIRST_DAY(:P_DTINICIAL),
                LAST_DAY(:P_DTFINAL),
                :P_VRITEM,
                :P_QTITEM,
                :P_QTDEITEMNAOUTIL,
                :P_QTDEITEMUTIL,
                :P_VRITEMNAOUTIL,
                :P_VRITEMUTIL,
                :P_NRORG,
                :P_DTINCLUSAO,
                :P_NRORGINCLUSAO,
                :P_CDOPERINCLUSAO,
                :P_IDITEM,
                :P_IDATIVO
            )"); 
        try{
            $stmt->execute($parametros);
        }catch(\Exception $ex){
            $response->setError(new Error("ERRO_OPERACAO2" . $ex->getMessage(), 500));
        }
        
    }
    
    public function saveDespesa(DTO\Request $request, DTO\Response $response){
        $row = $request->getDataSet()->getRows()[0];
        $parametros = array(
                'P_NRDETALHEPROJEMANROP' => $this->newCode->getCodeByTableName("DETALHEPROJEMANROP", $this->environment->getNrorg()),
                'P_CDITEM' => $row['CDITEM'],
                'P_DSITEM' => $row['DSITEM'],
                'P_CDFILIAL' => $row['CDFILIAL'],
                'P_DTINICIAL' => $row['DTINICIAL'],
                'P_DTFINAL' => $row['DTFINAL'],
                'P_VRITEM' => $row['VRITEM'],
                'P_NRORG' => $this->environment->getNrorg(),
                'P_DTINCLUSAO' => $this->crudService->getEnvironment()->getCurrentTime()->format("d/m/Y H:i:s"),
                'P_NRORGINCLUSAO' => $this->environment->getNrorg(),
                'P_CDOPERINCLUSAO' => $this->environment->getCdOperador(),
                'P_IDITEM' => $row['IDITEM'],
                'P_IDATIVO' => 'S'
            );
         $stmt = $this->connection->prepare("
             INSERT INTO
                DETALHEPROJEMANROP 
            (
                NRDETALHEPROJEMANROP,
                CDITEM,
                DSITEM,
                CDFILIAL,
                DTINICIAL,
                DTFINAL,
                VRITEM,
                NRORG,
                DTINCLUSAO,
                NRORGINCLUSAO,
                CDOPERINCLUSAO,
                IDITEM,
                IDATIVO
             ) 
            VALUES(
                :P_NRDETALHEPROJEMANROP,
                :P_CDITEM,
                :P_DSITEM,
                :P_CDFILIAL,
                FIRST_DAY(:P_DTINICIAL),
                LAST_DAY(:P_DTFINAL),
                :P_VRITEM,
                :P_NRORG,
                :P_DTINCLUSAO,
                :P_NRORGINCLUSAO,
                :P_CDOPERINCLUSAO,
                :P_IDITEM,
                :P_IDATIVO
            )"); 
        try{
            $stmt->execute($parametros);
        }catch(\Exception $ex){
            $response->setError(new Error("ERRO_OPERACAO2" . $ex->getMessage(), 500));
        }
    }
    
    public function saveMaoDeObra(DTO\Request $request, DTO\Response $response){
        $row = $request->getDataSet()->getRows()[0];
        $parametros = array(
                'P_NRDETALHEPROJEMANROP' => $this->newCode->getCodeByTableName("DETALHEPROJEMANROP", $this->environment->getNrorg()),
                'P_CDITEM' => $row['CDITEM'],
                'P_DSITEM' => $row['DSITEM'],
                'P_CDFILIAL' => $row['CDFILIAL'],
                'P_DTINICIAL' => $row['DTINICIAL'],
                'P_DTFINAL' => $row['DTFINAL'],
                'P_VRITEM' => $row['VRITEM'],
                'P_NRORG' => $this->environment->getNrorg(),
                'P_DTINCLUSAO' => $this->crudService->getEnvironment()->getCurrentTime()->format("d/m/Y H:i:s"),
                'P_NRORGINCLUSAO' => $this->environment->getNrorg(),
                'P_CDOPERINCLUSAO' => $this->environment->getCdOperador(),
                'P_IDITEM' => $row['IDITEM'],
                'P_IDATIVO' => 'S'
            );
        $stmt = $this->connection->prepare("
             INSERT INTO
                DETALHEPROJEMANROP 
            (
                NRDETALHEPROJEMANROP,
                CDITEM,
                DSITEM,
                CDFILIAL,
                DTINICIAL,
                DTFINAL,
                VRITEM,
                NRORG,
                DTINCLUSAO,
                NRORGINCLUSAO,
                CDOPERINCLUSAO,
                IDITEM,
                IDATIVO
             ) 
            VALUES(
                :P_NRDETALHEPROJEMANROP,
                :P_CDITEM,
                :P_DSITEM,
                :P_CDFILIAL,
                FIRST_DAY(:P_DTINICIAL),
                LAST_DAY(:P_DTFINAL),
                :P_VRITEM,
                :P_NRORG,
                :P_DTINCLUSAO,
                :P_NRORGINCLUSAO,
                :P_CDOPERINCLUSAO,
                :P_IDITEM,
                :P_IDATIVO
            )"); 
            
        try{
            $stmt->execute($parametros);
            $this->updateProjecaoDetalhamento($row);
            
        }catch(\Exception $ex){
            $response->setError(new Error("ERRO_OPERACAO2" . $ex->getMessage(), 500));
        }
    }
    
    public function updateDetalhamento(DTO\Request $request, DTO\Response $response){
        $row = $request->getDataSet()->getRows()[0];
            
        try{
            $this->updateProjecaoDetalhamento($row);
        }catch(\Exception $ex){
            $response->setError(new Error("ERRO_OPERACAO2" . $ex->getMessage(), 500));
        }
    }

    public function getVariables(DTO\Request $request, DTO\Response $response){
        $row = $request->getDataSet()->getRows()[0];

		$stmt = $this->connection->prepare("
			SELECT P.IDCALCPERCENTFAT,
              NRDIA_UTIL,
              CASE
                WHEN NRDIA_REALIZADO = 0
                THEN 1
                ELSE NRDIA_REALIZADO
              END NRDIA_REALIZADO,
              DECODE(DTINICOMP, DTINI, DECODE(DTFINALCOMP, DTFINAL,'N','S'),'S') CALC_PROJ,
              P.IDCALCIMPFAT,
              P.IDTIPOCALCTAXAADM
            FROM PARFILIALROP P,
              (SELECT RETORNA_DIA_UTIL(:P_CDFILIAL,:P_DATAINI,LAST_DAY(:P_DATAFIN))       AS NRDIA_UTIL,
                RETORNA_DIAS_REALIZADOS(TIPOPARAM_DRO(:P_CDFILIAL),:P_DATAINI,:P_DATAFIN) AS NRDIA_REALIZADO,
                :P_DATAFIN                                                                AS DTFINAL,
                :P_DATAINI DTINI,
                LAST_DAY(:P_DATAFIN) DTFINALCOMP,
                FIRST_DAY(:P_DATAINI) DTINICOMP
              FROM DUAL
              ) D
            WHERE P.CDFILIAL = TIPOPARAM_DRO(:P_CDFILIAL)"
		);
		$stmt->execute(
			array(
				'P_CDFILIAL' => $row['P_CDFILIAL'],
                'P_DATAINI' => $row['DTINICROP'],
                'P_DATAFIN' => $row['DTFINALROP']
			)
		);
		$result = $stmt->fetchAll();
		$response->addDataSet(new DataSet("RESULT", $result));
    }
    
    public function updateProjecaoDetalhamento ($row){
        switch ($row['DETALHAMENTO']){
            case 'INVESTIMENTO':
                $item_to_update = 'VRINVESTMAN';
                $iditem = "'IM', 'IC'";
                break;
                
            case 'MAOOBRA':
                $item_to_update = 'VRMAOOBRAMAN';
                $iditem = "'MM', 'MC', 'MP'";
                break;
            
            case 'DESPESA':
                $item_to_update = 'VROUTRDESPMAN';
                $iditem = "'DD', 'DE', 'DC'";
                break;
                
            case 'FATURAMENTO_EFETIVO':
                $item_to_update = 'VRFATBRUTMAN';
                $iditem = "'FE'";
                break;
                
        }

        $parametros_projecao = array(
                "P_NRPROJECAOMANUALROP" => $row['NRPROJECAOMANUALROP'],
                'P_DTINICIAL' => $row['DTINICIAL'],
                'P_DTFINAL' => $row['DTFINAL'],
            );
        $stmt_projecao = $this->connection->prepare("
            UPDATE PROJECAOMANUALROP SET ".$item_to_update." = (SELECT SUM(VRITEM) FROM DETALHEPROJEMANROP WHERE IDITEM IN (".$iditem.") AND DTINICIAL BETWEEN '01/'
                        || TO_CHAR(TO_DATE(:P_DTINICIAL),'MM/YYYY') AND LAST_DAY(:P_DTFINAL))
                    WHERE NRPROJECAOMANUALROP = :P_NRPROJECAOMANUALROP
         
         ");
         
        $stmt_projecao->execute($parametros_projecao);
    }
    public function inserirProjecao (DTO\Request $request, DTO\Response $response){
        
        $rows = $request->getDataSet()->getRows()[0];
        
        $query = "SELECT DTINICIAL, DTFINAL FROM PROJECAOMANUALROP WHERE DTINICIAL = :P_DTINICIAL AND DTFINAL = :P_DTFINAL AND :P_CDFILIAL = CDFILIAL";
        $params = array(
             "P_CDFILIAL"  => $rows['P_CDFILIAL'],
            "P_DTINICIAL" =>$rows['DTINICROP'],
            "P_DTFINAL" =>$rows['DTFINALROP']
        );
        $stmt = $this->connection->prepare($query);
        $stmt->execute($params);
        $data =  $stmt->fetchAll();
      
        if($data == null) {
            $query = "select DSDESCRICAOTOP, VRPROJECAO from table (RESUMO_ROP(:P_CDFILIAL,TO_DATE(:P_DTINICIAL,'DD/MM/YYYY'),TO_DATE(:P_DTFINAL,'DD/MM/YYYY'),'S','N','M') )";
            $stmt = $this->connection->prepare($query);
            $stmt->execute($params);
            $valorProjecao =  $stmt->fetchAll();
            $valor_float = floatval(0);
            $parametros = array(
                "P_NRPROJECAOMANUALROP" => $this->newCode->getCodeByTableName('PROJECAOMANUALROP', $this->environment->getNrorgTrab(), 1, 10, false),
                "P_CDFILIAL"  => $rows['P_CDFILIAL'],
                "CD_DTINICIAL" => $rows['DTINICROP'],
                "CD_DTFINAL" => $rows['DTFINALROP'],
                "FATEFET" => $valor_float,
                "FATFOR" => $valor_float,
                "CMV" => $valor_float,
                "DESPESA" => $valor_float,
                "MAOBRA" => $valor_float,
                "DEPRE" => $valor_float,
                "DEDUCR" => $valor_float,
                "TAXADM" => $valor_float,
                "INVEST" => $valor_float,
                "FATNF" => $valor_float,
                "FATDIV" => $valor_float,
                "FATRECEXTRA" => $valor_float,
                "DEDUIM" => $valor_float,
                "DEDUDES" => $valor_float,
                "DEDUEN" => $valor_float,
                "AJUST" => $valor_float,
                "DEBCRE" => $valor_float,
                "DEDUDEV" => $valor_float
            );
            
            foreach($valorProjecao as $linha){
                switch ($linha['DSDESCRICAOTOP']){
                    
                    
                    case 'FATEFET':
                        $parametros['FATEFET'] = $linha['VRPROJECAO'];
                        break;
                        //ok
                    case 'FATNF':
                        $parametros['FATNF'] = $linha['VRPROJECAO'];
                        break;
                        //ok
                    case 'FATFOR':
                        $parametros['FATFOR'] = $linha['VRPROJECAO'];
                        break; 
                        //ok
                    case 'FATDIV':
                        $parametros['FATDIV'] = $linha['VRPROJECAO'];
                        break;
                        //ok
                    case 'FATRECEXTRA':
                        $parametros['FATRECEXTRA'] = $linha['VRPROJECAO'];
                        break;
                        //ok
                    case 'DEDUIM':
                        $parametros['DEDUIM'] = $linha['VRPROJECAO'];
                        break;
                        //ok
                    case 'DEDUCR':
                        $parametros['DEDUCR'] = $linha['VRPROJECAO'];
                        break;
                        //ok
                    case 'DEDUDES':
                        $parametros['DEDUDES'] = $linha['VRPROJECAO'];
                        break;
                        //ok
                    case 'DEDUEN':
                        $parametros['DEDUEN'] = $linha['VRPROJECAO'];
                        break;
                        //ok
                    case 'TAXADM':
                        $parametros['TAXADM'] = $linha['VRPROJECAO'];
                        break;
                        //ok
                    case 'CMV':
                        $parametros['CMV'] = $linha['VRPROJECAO'];
                        break;
                        //ok
                    case 'DESPESA':
                        $parametros['DESPESA'] = $linha['VRPROJECAO'];
                        break;
                        //ok
                    case 'AJUST':
                        $parametros['AJUST'] = $linha['VRPROJECAO'];
                        break;
                        //ok
                    case 'DEBCRE':
                        $parametros['DEBCRE'] = $linha['VRPROJECAO'];
                        break;
                        //ok
                    case 'MAOBRA':
                        $parametros['MAOBRA'] = $linha['VRPROJECAO'];
                        break;
                        //ok
                    case 'DEPRE':
                        $parametros['DEPRE'] = $linha['VRPROJECAO'];
                        break;
                        //ok
                    case 'INVEST':
                        $parametros['INVEST'] = $linha['VRPROJECAO'];
                        break;
                        //ok
                    case 'DEDUDEV':
                        $parametros['DEDUDEV'] = $linha['VRPROJECAO'];
                        break;
                        //ok
                }
            }
            
            $query ="INSERT INTO PROJECAOMANUALROP ( NRPROJECAOMANUALROP, CDFILIAL, DTINICIAL, DTFINAL, VRFATBRUTMAN, VRFATFOSMAN, VRCONSUMOMAN, VROUTRDESPMAN, VRMAOOBRAMAN, VRDEPRBENSMAN, VRCREDIMPMAN, VRTAXAADMMAN, VRINVESTMAN, VRFATNFMAN, VRFATDIVMAN, VRFATRECEXTRAMAN, VRIMPOSTOMAN, VRDESCSOBVENDAMAN, VRENCARGOMAN, VRAJUSTEMAN, VRDEBCREMAN, VRDEDUDEVMAN ) VALUES ( :P_NRPROJECAOMANUALROP, :P_CDFILIAL, :CD_DTINICIAL, :CD_DTFINAL, :FATEFET , :FATFOR , :CMV , :DESPESA , :MAOBRA , :DEPRE , :DEDUCR, :TAXADM, :INVEST, :FATNF, :FATDIV, :FATRECEXTRA, :DEDUIM, :DEDUDES, :DEDUEN, :AJUST, :DEBCRE, :DEDUDEV )";
            $stmt = $this->connection->prepare($query);
            $stmt->execute($parametros);
        }
    }
}
